//Hardware connections:

//                    +10µF 
//PIN 11 ---[ 1k ]--+---||--->> Audio out
//                  |
//                 === 10nF
//                  |
//                 GND

//setupVoice( voice[0-3] , waveform[SINE,TRIANGLE,SQUARE,SAW,RAMP,NOISE] , pitch[0-127], envelope[ENVELOPE0-ENVELOPE3], length[0-127], mod[0-127, 64=no mod])

//  NAME_OF_THE_SYNTH.mTrigger(VOICE,MIDI_NOTE_NUMBER)

/* Buttons to note equivalency
No button  - C4 - 60
        A  - D4 - 62
        B  - E4 - 63
        Z  - G4 - 67
     Down  - F4 - 65
    Right  - A4 - 69
     Left  - B4 - 71
       Up  - D5 - 74
*/

//====================================================================================================
//====================================================================================================


#include <synth.h>
synth OOT;    //-Make a synth

# define MIC_VALUE A0

# define BUT_A 2
# define BUT_B 3
# define BUT_Z 4
# define BUT_LEFT 5
# define BUT_UP 6
# define BUT_RIGHT 7
# define BUT_DOWN 8


//# define HALFER 10   // --- future development

# define NUM_BUTTONS 7

int Buttons [NUM_BUTTONS] = {BUT_A,BUT_B,BUT_Z,BUT_LEFT,BUT_UP,BUT_DOWN,BUT_RIGHT};
int BasePitch = 60;
int Note [NUM_BUTTONS] = { 62, 64, 67 ,71,74 ,65 ,69};
int LoopChecker;

boolean AllOff;
//====================================================================================================
//====================================================================================================

void AllOffCheck (){
  for (int i = 0 ; i<NUM_BUTTONS;i++)
    {
      if ( digitalRead (Buttons[i]) == LOW )
      {
        LoopChecker += 1;
       }
      }
       if ( LoopChecker == NUM_BUTTONS )
      {
        AllOff = true;
       }
       else {
       AllOff = false;
            }
  LoopChecker = 0;
}

void setup() 
{
  Serial.begin(9600);

  //SYNTH Stuff --------------------------------
  OOT.begin();  
  OOT.setupVoice(0,SINE  ,60,ENVELOPE3,127,64);

  //PINMODE ATTRIBUTION ------------------------
  for (int i = 0; i< NUM_BUTTONS; i++)
      {
        pinMode ( Buttons [i], INPUT); 
      }
//pinMode ( HALFER, INPUT);
  pinMode ( MIC_VALUE, INPUT);
  Serial.begin (9600);
}

//====================================================================================================
//====================================================================================================

void loop()
{

  if ( analogRead (MIC_VALUE)>100)
  {
    
    for (int i = 0 ; i<NUM_BUTTONS;i++)
    {
      if ( digitalRead (Buttons[i]) == HIGH )
      {
       while (digitalRead (Buttons[i]) == HIGH) 
       {
         Serial.println ("playin Note[i]");
        Serial.println (Note[i]);
        OOT.mTrigger(0,Note[i]);
        
       } Serial.println ("Got out of the while");
      }
      }
     AllOffCheck();
       Serial.println ("Got out of the for");
       while(AllOff == true && analogRead (MIC_VALUE)>100) 
       {
        Serial.println ("basepitch");
        //Serial.println ();
        OOT.mTrigger(0,BasePitch);
       AllOffCheck();
       }
      }
   
    
  }
